diff -ruN boost_org/tools/build/src/tools/qcc.jam boost_patch/tools/build/src/tools/qcc.jam
--- boost_org/tools/build/src/tools/qcc.jam	2021-07-19 16:31:06.744074617 -0400
+++ boost_patch/tools/build/src/tools/qcc.jam	2021-07-19 16:13:35.493182000 -0400
@@ -1,7 +1,6 @@
 #  Copyright (c) 2001 David Abrahams.
 #  Copyright (c) 2002-2003 Rene Rivera.
 #  Copyright (c) 2002-2003 Vladimir Prus.
-#  Copyright (c) 2020 Alexander Karzhenkov.
 #
 #  Use, modification and distribution is subject to the Boost Software
 #  License Version 1.0. (See accompanying file LICENSE_1_0.txt or
@@ -22,6 +21,7 @@
 feature.extend toolset : qcc ;
 
 toolset.inherit-generators qcc : unix : unix.link unix.link.dll ;
+generators.override builtin.lib-generator : qcc.prebuilt ;
 toolset.inherit-flags qcc : unix ;
 toolset.inherit-rules qcc : unix ;
 
@@ -38,7 +38,7 @@
 rule init ( version ? : command * : options * )
 {
     local condition = [ common.check-init-parameters qcc : version $(version) ] ;
-    local command = [ common.get-invocation-command qcc : QCC : $(command) ] ;
+    local command = [ common.get-invocation-command qcc : qcc : $(command) ] ;
     common.handle-options qcc : $(condition) : $(command) : $(options) ;
 }
 
@@ -48,45 +48,8 @@
 generators.register-c-compiler qcc.compile.asm : ASM : OBJ : <toolset>qcc ;
 
 
-# Select QCC target platform
-
-# Configuration checks don't use explicit value of QCC-TARGET-PLATFORM
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>/<address-model> : NA ;
-
-# Combinations supported by both QNX 6.5.0 and QNX 7.0.0
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>x86/<address-model>32 : -Vgcc_ntox86 ;
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>arm/<address-model>32 : -Vgcc_ntoarmv7le ;
-
-# Combinations supported by QNX 7.0.0
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>x86/<address-model>64 : -Vgcc_ntox86_64 ;
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>arm/<address-model>64 : -Vgcc_ntoaarch64le ;
-
-# Combinations supported by QNX 6.5.0
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>power/<address-model>32 : -Vgcc_ntoppcbe ;
-toolset.flags qcc QCC-TARGET-PLATFORM <architecture>mips1/<address-model>32 : -Vgcc_ntomipsle ;
-
-# There are also excluded alternatives (supported by QNX 6.5.0)
-# toolset.flags qcc QCC-TARGET-PLATFORM <architecture>arm/<address-model>32 : -Vgcc_ntoarmle ;
-# toolset.flags qcc QCC-TARGET-PLATFORM <architecture>power/<address-model>32 : -Vgcc_ntoppcbespe ;
-# toolset.flags qcc QCC-TARGET-PLATFORM <architecture>mips1/<address-model>32 : -Vgcc_ntomipsbe ;
-
-local rule check-target-platform
-{
-    local opt = [ on $(1) return $(QCC-TARGET-PLATFORM) ] ;
-
-    if $(opt) = NA
-    {
-        # Configuration checks are performed
-        QCC-TARGET-PLATFORM on $(1) = ;
-    }
-    else if ! $(opt)
-    {
-        errors.user-error "Unsupported achitecture / address model" ;
-    }
-}
-
 # Declare flags for compilation.
-toolset.flags qcc.compile OPTIONS <debug-symbols>on : -gstabs+ ;
+toolset.flags qcc.compile OPTIONS <debug-symbols>on : -g ;
 
 # Declare flags and action for compilation.
 toolset.flags qcc.compile OPTIONS <optimization>off : -O0 ;
@@ -99,17 +62,10 @@
 
 toolset.flags qcc.compile OPTIONS <warnings>off : -w ;
 toolset.flags qcc.compile OPTIONS <warnings>all : -Wc,-Wall ;
-toolset.flags qcc.compile OPTIONS <warnings>extra : -Wc,-Wall -Wc,-Wextra ;
-toolset.flags qcc.compile OPTIONS <warnings>pedantic : -Wc,-Wall -Wc,-Wextra -Wc,-pedantic ;
 toolset.flags qcc.compile OPTIONS <warnings-as-errors>on : -Wc,-Werror ;
 
 toolset.flags qcc.compile OPTIONS <profiling>on : -p ;
 
-toolset.flags qcc.compile OPTIONS <local-visibility>hidden : -fvisibility=hidden ;
-toolset.flags qcc.compile.c++ OPTIONS <local-visibility>hidden : -fvisibility-inlines-hidden ;
-toolset.flags qcc.compile OPTIONS <local-visibility>protected : -fvisibility=protected ;
-toolset.flags qcc.compile OPTIONS <local-visibility>global : -fvisibility=default ;
-
 toolset.flags qcc.compile OPTIONS <cflags> ;
 toolset.flags qcc.compile.c++ OPTIONS <cxxflags> ;
 toolset.flags qcc.compile DEFINES <define> ;
@@ -134,35 +90,23 @@
     local template-depth = [ on $(1) return $(TEMPLATE_DEPTH) ] ;
     if ! $(template-depth)
     {
-        TEMPLATE_DEPTH on $(1) = 128 ;
+        TEMPLATE_DEPTH on $(1) = 256 ;
     }
-
-    check-target-platform $(1) ;
 }
 
 actions compile.c++
 {
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) -Wc,-ftemplate-depth-$(TEMPLATE_DEPTH) $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
-}
-
-rule compile.c
-{
-    check-target-platform $(1) ;
+    "$(CONFIG_COMMAND)" -Wc,-ftemplate-depth-$(TEMPLATE_DEPTH) $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
 }
 
 actions compile.c
 {
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) -lang-c $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
-}
-
-rule compile.asm
-{
-    check-target-platform $(1) ;
+    "$(CONFIG_COMMAND)" $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
 }
 
 actions compile.asm
 {
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
+    "$(CONFIG_COMMAND)" -xassembler $(OPTIONS) -D$(DEFINES) -I"$(INCLUDES)" -c -o "$(<)" "$(>)"
 }
 
 
@@ -216,7 +160,7 @@
 
 # Declare flags for linking.
 # First, the common flags.
-toolset.flags qcc.link OPTIONS <debug-symbols>on : -gstabs+ ;
+toolset.flags qcc.link OPTIONS <debug-symbols>on : -g ;
 toolset.flags qcc.link OPTIONS <profiling>on : -p ;
 toolset.flags qcc.link OPTIONS <linkflags> ;
 toolset.flags qcc.link LINKPATH <library-path> ;
@@ -244,12 +188,11 @@
     # parallel is just slower. For now, serialize only qcc links while it might
     # be a good idea to serialize all links.
     JAM_SEMAPHORE on $(targets) = <s>qcc-link-semaphore ;
-    check-target-platform $(1) ;
 }
 
 actions link bind LIBRARIES
 {
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) -L"$(LINKPATH)" -Wl,-R$(SPACE)-Wl,"$(RPATH)" -Wl,-rpath-link$(SPACE)-Wl,"$(RPATH_LINK)" -o "$(<)" "$(>)" "$(LIBRARIES)" -l$(FINDLIBS-ST) -l$(FINDLIBS-SA) $(OPTIONS)
+    "$(CONFIG_COMMAND)" -L"$(LINKPATH)" -Wl,-R$(SPACE)-Wl,"$(RPATH)" -Wl,-rpath-link$(SPACE)-Wl,"$(RPATH_LINK)" -o "$(<)" "$(>)" "$(LIBRARIES)" -l$(FINDLIBS-ST) -l$(FINDLIBS-SA) $(OPTIONS)
 }
 
 
@@ -264,6 +207,10 @@
     RM = "if exist \"$(<[1])\" DEL \"$(<[1])\""  ;
 }
 
+# Declare flags for archive.
+CCVER = [ os.environ CCVER ] ;
+toolset.flags qcc.archive .RANLIB : nto$(CCVER)-ranlib ;
+.RANLIB = nto$(CCVER)-ranlib ;
 
 # Declare action for creating static libraries. The 'r' letter means to add
 # files to the archive with replacement. Since we remove the archive, we do not
@@ -273,16 +220,11 @@
 #
 # Use qcc driver to create archive, see
 #     http://www.qnx.com/developers/docs/6.3.2/neutrino/utilities/q/qcc.html
-
-rule archive
-{
-    check-target-platform $(1) ;
-}
-
 actions piecemeal archive
 {
     $(RM) "$(<)"
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) -A "$(<)" "$(>)"
+    "$(CONFIG_COMMAND)" -A "$(<)" "$(>)"
+    "$(.RANLIB)" "$(<)"
 }
 
 
@@ -290,7 +232,6 @@
 {
     SPACE on $(targets) = " " ;
     JAM_SEMAPHORE on $(targets) = <s>qcc-link-semaphore ;
-    check-target-platform $(1) ;
 }
 
 
@@ -298,5 +239,5 @@
 #
 actions link.dll bind LIBRARIES
 {
-    "$(CONFIG_COMMAND)" $(QCC-TARGET-PLATFORM) -L"$(LINKPATH)" -Wl,-R$(SPACE)-Wl,"$(RPATH)" -o "$(<)" -Wl,-h$(SPACE)-Wl,$(<[1]:D=) -shared "$(>)"  "$(LIBRARIES)" -l$(FINDLIBS-ST) -l$(FINDLIBS-SA) $(OPTIONS)
+    "$(CONFIG_COMMAND)" -L"$(LINKPATH)" -Wl,-R$(SPACE)-Wl,"$(RPATH)" -o "$(<)" -Wl,-h$(<[1]:D=) -shared "$(>)"  "$(LIBRARIES)" -l$(FINDLIBS-ST) -l$(FINDLIBS-SA) $(OPTIONS)
 }
diff -ruN boost_org/user-config.jam boost_patch/user-config.jam
--- boost_org/user-config.jam	1969-12-31 19:00:00.000000000 -0500
+++ boost_patch/user-config.jam	2021-07-19 16:13:35.541176000 -0400
@@ -0,0 +1,12 @@
+import os ;
+local QNX_HOST = [ os.environ QNX_HOST ] ;
+local QNX_TARGET = [ os.environ QNX_TARGET ] ;
+local CPUVARDIR = [ os.environ CPUVARDIR ] ;
+
+using python
+     : 3.8
+     : /usr/bin/python3.8
+     : $(QNX_TARGET)/$(CPUVARDIR)/usr/include/python3.8 $(QNX_TARGET)/usr/include/python3.8
+     : $(QNX_TARGET)/$(CPUVARDIR)/usr/lib
+     : <target-os>qnxnto <toolset>qcc
+     ;
